
;-------------------------------------------------------------------------------------

A9999   PROC

;convert value in eax (0 to 9,999) into four ASCII digits
;DednDave, 9-2009
;uses increased-precision multiply-by-inverse-to-divide
;(requires 3 more bits of resolution than normal to acquire the remainder)

;multiply by 5243

        mov     edx,eax
        shl     eax,1
        add     edx,eax
        shl     eax,2
        add     edx,eax
        shl     eax,1
        add     edx,eax
        shl     eax,1
        add     edx,eax
        shl     eax,1
        add     edx,eax
        shl     eax,4
        add     edx,eax
        shl     eax,2
        add     eax,edx

;divide by 8

        shr     eax,3

;fraction in edx

        xor     edx,edx
        mov     dl,ah

;multiply the fraction by 100 and round it off to get the remainder

        shl     edx,2
        mov     ax,dx
        shl     edx,3
        add     ax,dx
        shl     edx,1
        add     ax,dx
        shl     al,1
        adc     ah,0

;low-order digits in al - split into two digits in ax

        mov     al,ah
        aam

;rearrange bytes - high order digits in ah

        bswap   eax

;high-order digits in al - split into two digits in ax

        mov     al,ah
        aam

;rearrange two high-order digits

        xchg    al,ah

;make all four digits ASCII numeric characters

        or      eax,30303030h
        ret

A9999   ENDP

;-------------------------------------------------------------------------------------
